diff -Nur -Xfreecivdiff.ignore freeciv-cvs/ai/advdomestic.c freeciv-patched/ai/advdomestic.c
--- freeciv-cvs/ai/advdomestic.c	2003-06-30 12:18:27.000000000 +0100
+++ freeciv-patched/ai/advdomestic.c	2003-06-30 12:17:40.000000000 +0100
@@ -479,6 +479,11 @@
       || !can_build_improvement(pcity, id))
       continue;
 
+    if (id == B_CITY) {
+      /* if (!built_elsewhere(pcity, B_WALL)) was counterproductive -- Syela */
+      values[id] = ai_eval_threat_land(pplayer, pcity);
+    }
+
     switch (id) {
     
     /* food/growth production */
@@ -605,10 +610,6 @@
      * anyway. It was so stupid, AI wouldn't start building walls until it was 
      * in danger and it would have no chance to finish them before it was too 
      * late */
-    case B_CITY:
-      /* if (!built_elsewhere(pcity, B_WALL)) was counterproductive -- Syela */
-      values[id] = ai_eval_threat_land(pplayer, pcity);
-      break;
     case B_COASTAL:
       values[id] = ai_eval_threat_sea(pplayer, pcity);
       break;
@@ -711,7 +712,7 @@
       break;
     case B_LEONARDO:
       unit_list_iterate(pcity->units_supported, punit) {
-        Unit_Type_id unit_id = can_upgrade_unittype(pplayer, punit->type);
+        Unit_Type_id unit_id = can_upgrade_unittype(pplayer, punit->type, TRUE);
         if (unit_id >= 0) {
           /* this is probably wrong -- Syela */
           j = 8 * unit_upgrade_price(pplayer, punit->type, unit_id);
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/ai/aicity.c freeciv-patched/ai/aicity.c
--- freeciv-cvs/ai/aicity.c	2003-06-30 12:18:27.000000000 +0100
+++ freeciv-patched/ai/aicity.c	2003-06-30 12:16:42.000000000 +0100
@@ -307,7 +307,7 @@
 {
   struct player *pplayer = city_owner(pcity);
   unit_list_iterate(map_get_tile(pcity->x, pcity->y)->units, punit) {
-    int id = can_upgrade_unittype(pplayer, punit->type);
+    int id = can_upgrade_unittype(pplayer, punit->type, TRUE);
     if (military && (!is_military_unit(punit) || !is_ground_unit(punit))) {
       /* Only upgrade military units this round */
       continue;
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/ai/aiunit.c freeciv-patched/ai/aiunit.c
--- freeciv-cvs/ai/aiunit.c	2003-06-30 12:18:26.000000000 +0100
+++ freeciv-patched/ai/aiunit.c	2003-06-30 12:17:55.000000000 +0100
@@ -370,18 +370,30 @@
 Is there a chance that a trireme would be lost, given information that 
 the player actually has.
 ***************************************************************/
-static bool is_likely_trireme_loss(struct player *pplayer, int x, int y) 
+static bool is_likely_ship_loss(struct unit *punit, int x, int y) 
 {
+  struct player *pplayer = unit_owner(punit);
+
   /*
    * If we are in a city or next to land, we have no chance of losing
    * the ship.  To make this really useful for ai planning purposes, we'd
    * need to confirm that we can exist/move at the x,y location we are given.
    */
-  if ((likely_ocean(x, y, pplayer) < 50) || 
-      is_likely_coastline(x, y, pplayer) ||
-      (player_owns_active_wonder(pplayer, B_LIGHTHOUSE))) {
+  if (!unit_flag(punit, F_TRIREME) || likely_ocean(x, y, pplayer) < 50
+      || is_likely_coastline(x, y, pplayer)) {
     return FALSE;
   } else {
+    struct eff_iter iter;
+    struct map_position mp;
+    mp.x = x;
+    mp.y = y;
+    eff_iterator_unit_init(&iter, punit->type, punit->type,
+			   unit_owner(punit), &mp);
+    while (eff_iterator_next(&iter)) {
+      if (iter.imeff->type == EFT_NO_SINK_DEEP) {
+        return FALSE;
+      }
+    }
     return TRUE;
   }
 }
@@ -424,8 +436,7 @@
    * is a city on the tile, or if the tile is not accessible, or if the 
    * tile is on a different continent, or if we're a barbarian and
    * the tile has a hut, don't go there. */
-  if ((unit_flag(punit, F_TRIREME) && 
-       is_likely_trireme_loss(pplayer, x, y))
+  if (is_likely_ship_loss(punit, x, y)
       || map_get_city(x, y)
       || map_get_continent(x, y) != continent
       || (is_barbarian(pplayer) && map_has_special(x, y, S_HUT))) {
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/citydlg_common.c freeciv-patched/client/citydlg_common.c
--- freeciv-cvs/client/citydlg_common.c	2003-06-30 12:18:24.000000000 +0100
+++ freeciv-patched/client/citydlg_common.c	2003-06-30 12:18:17.000000000 +0100
@@ -136,9 +136,9 @@
   stock = pcity->shield_stock;
 
   if (pcity->is_building_unit) {
-    cost = get_unit_type(pcity->currently_building)->build_cost;
+    cost = unit_value_adjusted(pcity->currently_building, pcity);
   } else {
-    cost = get_improvement_type(pcity->currently_building)->build_cost;
+    cost = improvement_value_adjusted(pcity->currently_building, pcity);
   }
 
   if (!pcity->is_building_unit && pcity->currently_building == B_CAPITAL) {
@@ -192,10 +192,10 @@
 
     if (is_unit) {
       name = get_unit_name(id);
-      cost = get_unit_type(id)->build_cost;
+      cost = unit_value_adjusted(id, pcity);
     } else {
       name = get_impr_name_ex(pcity, id);
-      cost = get_improvement_type(id)->build_cost;
+      cost = improvement_value_adjusted(id, pcity);
     }
 
     if (turns < 999) {
@@ -231,7 +231,7 @@
       my_snprintf(buf[1], column_size, "%d/%d/%d", ptype->attack_strength,
 		  ptype->defense_strength, ptype->move_rate / 3);
     }
-    my_snprintf(buf[2], column_size, "%d", ptype->build_cost);
+    my_snprintf(buf[2], column_size, "%d", unit_value_adjusted(id, pcity));
   } else {
     /* Total & turns left meaningless on capitalization */
     if (id == B_CAPITAL) {
@@ -260,7 +260,7 @@
       }
 
       my_snprintf(buf[2], column_size, "%d",
-		  get_improvement_type(id)->build_cost);
+		  improvement_value_adjusted(id, pcity));
     }
   }
 
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/cityrepdata.c freeciv-patched/client/cityrepdata.c
--- freeciv-cvs/client/cityrepdata.c	2003-06-30 12:18:24.000000000 +0100
+++ freeciv-patched/client/cityrepdata.c	2003-06-30 12:18:17.000000000 +0100
@@ -374,10 +374,10 @@
 
     if(pcity->is_building_unit) {
       name = get_unit_type(pcity->currently_building)->name;
-      cost = get_unit_type(pcity->currently_building)->build_cost;
+      cost = unit_value_adjusted(pcity->currently_building, pcity);
     } else {
       name = get_impr_name_ex(pcity, pcity->currently_building);
-      cost = get_improvement_type(pcity->currently_building)->build_cost;
+      cost = improvement_value_adjusted(pcity->currently_building, pcity);
     }
 
     my_snprintf(buf, sizeof(buf), "%s (%d/%d/%s/%d)%s", name,
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/climisc.c freeciv-patched/client/climisc.c
--- freeciv-cvs/client/climisc.c	2003-06-30 12:18:25.000000000 +0100
+++ freeciv-patched/client/climisc.c	2003-06-30 12:18:17.000000000 +0100
@@ -132,7 +132,7 @@
 
   built_impr_iterate(pcity, i) {
     effect_update = TRUE;
-    city_remove_improvement(pcity, i);
+    city_remove_improvement(pcity, i, TRUE);
   } built_impr_iterate_end;
 
   if (effect_update) {
@@ -624,7 +624,7 @@
 
     if (is_unit) {
       name = get_unit_name(id);
-      cost = get_unit_type(id)->build_cost;
+      cost = unit_value_adjusted(id, pcity);
       pitem->section = unit_type_flag(id, F_NONMIL) ? 2 : 3;
     } else {
       name = get_impr_name_ex(pcity, id);
@@ -632,7 +632,7 @@
 	cost = -1;
 	pitem->section = 1;
       } else {
-	cost = get_improvement_type(id)->build_cost;
+	cost = improvement_value_adjusted(id, pcity);
 	if (is_wonder(id)) {
       	  pitem->section = 4;
         } else {
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/gui-gtk/citydlg.c freeciv-patched/client/gui-gtk/citydlg.c
--- freeciv-cvs/client/gui-gtk/citydlg.c	2003-06-30 12:18:27.000000000 +0100
+++ freeciv-patched/client/gui-gtk/citydlg.c	2003-06-30 12:18:17.000000000 +0100
@@ -1901,7 +1901,7 @@
   get_city_dialog_production(pcity, buf, sizeof(buf));
 
   if (pcity->is_building_unit) {
-    cost = get_unit_type(pcity->currently_building)->build_cost;
+    cost = unit_value_adjusted(pcity->currently_building, pcity);
     descr = get_unit_type(pcity->currently_building)->name;
   } else {
     if (pcity->currently_building == B_CAPITAL) {
@@ -1909,7 +1909,7 @@
       gtk_widget_set_sensitive(pdialog->overview.buy_command, FALSE);
       cost = 0;
     } else {
-      cost = get_improvement_type(pcity->currently_building)->build_cost;;
+      cost = improvement_value_adjusted(pcity->currently_building, pcity);
     }
     descr = get_impr_name_ex(pcity, pcity->currently_building);
   }
@@ -2525,7 +2525,7 @@
     if (punit->homecity == pcity->id) {
       message_dialog_button_set_sensitive(wd, "button5", FALSE);
     }
-    if (can_upgrade_unittype(game.player_ptr, punit->type) == -1) {
+    if (can_upgrade_unittype(game.player_ptr, punit->type, TRUE) == -1) {
       message_dialog_button_set_sensitive(wd, "button6", FALSE);
     }
   }
@@ -2679,7 +2679,7 @@
 
   if ((punit = player_find_unit_by_id(game.player_ptr, (size_t) data))) {
     ut1 = punit->type;
-    ut2 = can_upgrade_unittype(game.player_ptr, ut1);
+    ut2 = can_upgrade_unittype(game.player_ptr, ut1, TRUE);
 
     if (ut2 == -1) {
       /* this shouldn't generally happen, but it is conceivable */
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/gui-gtk/gotodlg.c freeciv-patched/client/gui-gtk/gotodlg.c
--- freeciv-cvs/client/gui-gtk/gotodlg.c	2003-06-30 12:18:27.000000000 +0100
+++ freeciv-patched/client/gui-gtk/gotodlg.c	2003-06-30 12:16:18.000000000 +0100
@@ -198,7 +198,7 @@
     if(!all_cities && i!=game.player_idx) continue;
     city_list_iterate(game.players[i].cities, pcity) {
       sz_strlcpy(name, pcity->name);
-      if (pcity->improvements[B_AIRPORT] == I_ACTIVE)
+      if (pcity->airlift)
 	sz_strlcat(name, "(A)");
       gtk_clist_append( GTK_CLIST( goto_list ), row );
     }
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/gui-gtk/happiness.c freeciv-patched/client/gui-gtk/happiness.c
--- freeciv-cvs/client/gui-gtk/happiness.c	2003-06-30 12:18:27.000000000 +0100
+++ freeciv-patched/client/gui-gtk/happiness.c	2003-06-30 12:16:03.000000000 +0100
@@ -78,8 +78,6 @@
 					      *pdialog);
 static void happiness_dialog_update_units(struct happiness_dialog
 					  *pdialog);
-static void happiness_dialog_update_wonders(struct happiness_dialog
-					    *pdialog);
 
 /****************************************************************
 ...
@@ -199,7 +197,6 @@
   happiness_dialog_update_luxury(pdialog);
   happiness_dialog_update_buildings(pdialog);
   happiness_dialog_update_units(pdialog);
-  happiness_dialog_update_wonders(pdialog);
 }
 
 /**************************************************************************
@@ -275,59 +272,36 @@
 }
 
 /**************************************************************************
-...
+  Lists the buildings or Wonders that contribute to happiness
 **************************************************************************/
-static void happiness_dialog_update_buildings(struct happiness_dialog
-					      *pdialog)
+static void set_building_label(char *title, int improvs[B_LAST],
+			       int numperline, char *linespacer,
+			       struct city *pcity, GtkWidget *label)
 {
   int faces = 0;
-  char buf[512], *bptr = buf;
-  int nleft = sizeof(buf);
-  struct city *pcity = pdialog->pcity;
-  struct government *g = get_gov_pcity(pcity);
+  char buf[512], *bptr;
+  int nleft, i;
+
+  nleft = sizeof(buf);
+  bptr = buf;
 
-  my_snprintf(bptr, nleft, _("Buildings: "));
+  my_snprintf(bptr, nleft, title);
   bptr = end_of_strn(bptr, &nleft);
 
-  if (city_got_building(pcity, B_TEMPLE)) {
-    faces++;
-    my_snprintf(bptr, nleft, get_improvement_name(B_TEMPLE));
-    bptr = end_of_strn(bptr, &nleft);
-    my_snprintf(bptr, nleft, _(". "));
-    bptr = end_of_strn(bptr, &nleft);
-  }
-  if (city_got_building(pcity, B_COURTHOUSE) && g->corruption_level == 0) {
-    faces++;
-    my_snprintf(bptr, nleft, get_improvement_name(B_COURTHOUSE));
-    bptr = end_of_strn(bptr, &nleft);
-    my_snprintf(bptr, nleft, _(". "));
-    bptr = end_of_strn(bptr, &nleft);
-  }
-  if (city_got_building(pcity, B_COLOSSEUM)) {
-    faces++;
-    my_snprintf(bptr, nleft, get_improvement_name(B_COLOSSEUM));
-    bptr = end_of_strn(bptr, &nleft);
-    my_snprintf(bptr, nleft, _(". "));
-    bptr = end_of_strn(bptr, &nleft);
-  }
-  /* hack for eliminating gtk_set_line_wrap() -mck */
-  if (faces > 2) {
-    /* sizeof("Buildings: ") */
-    my_snprintf(bptr, nleft, _("\n              "));
-    bptr = end_of_strn(bptr, &nleft);
-  }
-  if (city_got_effect(pcity, B_CATHEDRAL)) {
-    faces++;
-    my_snprintf(bptr, nleft, get_improvement_name(B_CATHEDRAL));
-    bptr = end_of_strn(bptr, &nleft);
-    if (!city_got_building(pcity, B_CATHEDRAL)) {
-      my_snprintf(bptr, nleft, _("("));
-      bptr = end_of_strn(bptr, &nleft);
-      my_snprintf(bptr, nleft, get_improvement_name(B_MICHELANGELO));
-      bptr = end_of_strn(bptr, &nleft);
-      my_snprintf(bptr, nleft, _(")"));
+  faces = 0;
+  for (i = 0;i < game.num_impr_types; i++) if (improvs[i]) {
+    /* hack for eliminating gtk_set_line_wrap() -mck */
+    if (faces && faces % numperline == 0) {
+      my_snprintf(bptr, nleft, linespacer);
       bptr = end_of_strn(bptr, &nleft);
     }
+    faces++;
+    if (city_got_building(pcity,i)) {
+      my_snprintf(bptr, nleft, get_improvement_name(i));
+    } else {
+      my_snprintf(bptr, nleft, _("(%s)"), get_improvement_name(i));
+    }
+    bptr = end_of_strn(bptr, &nleft);
     my_snprintf(bptr, nleft, _(". "));
     bptr = end_of_strn(bptr, &nleft);
   }
@@ -337,7 +311,53 @@
     bptr = end_of_strn(bptr, &nleft);
   }
 
-  gtk_set_label(pdialog->hlabels[BUILDINGS], buf);
+  gtk_set_label(label, buf);
+}
+
+/**************************************************************************
+  Updates the lists of ordinary buildings and Wonders that affect the
+  number of happy/content citizens, using ruleset improvement effects
+**************************************************************************/
+static void happiness_dialog_update_buildings(struct happiness_dialog
+					      *pdialog)
+{
+  struct city *pcity = pdialog->pcity;
+  int i, improvs[B_LAST], forceimprovs[B_LAST];
+  Impr_Type_id impr;
+
+  for (i = 0; i < game.num_impr_types; i++) {
+    improvs[i] = forceimprovs[i] = FALSE;
+  }
+
+  city_effects_iterate(iter, pcity) {
+    switch(iter.imeff->type) {
+    case EFT_MAKE_CONTENT:
+    case EFT_MAKE_CONTENT_PCT:
+    case EFT_MAKE_HAPPY:
+      impr = eff_iterator_get_improvement(&iter);
+      if (improvement_exists(impr)) {
+        improvs[impr] = TRUE;
+      }
+      break;
+    case EFT_FORCE_CONTENT:
+    case EFT_FORCE_CONTENT_PCT:
+    case EFT_FORCE_HAPPY:
+      impr = eff_iterator_get_improvement(&iter);
+      if (improvement_exists(impr)) {
+        forceimprovs[impr] = TRUE;
+      }
+      break;
+    default:
+      break;
+    }
+  } city_effects_iterate_end;
+
+  set_building_label(_("Buildings: "), improvs, 3,
+                     _("\n              "),	/* sizeof("Buildings: ") */
+                     pcity, pdialog->hlabels[BUILDINGS]);
+  set_building_label(_("Wonders: "), forceimprovs, 2,
+                     _("\n              "),	/* sizeof("Wonders: ") */
+                     pcity, pdialog->hlabels[WONDERS]);
 }
 
 /**************************************************************************
@@ -384,62 +404,6 @@
 /**************************************************************************
 ...
 **************************************************************************/
-static void happiness_dialog_update_wonders(struct happiness_dialog
-					    *pdialog)
-{
-  int faces = 0;
-  char buf[512], *bptr = buf;
-  int nleft = sizeof(buf);
-  struct city *pcity = pdialog->pcity;
-
-  my_snprintf(bptr, nleft, _("Wonders: "));
-  bptr = end_of_strn(bptr, &nleft);
-
-  if (city_affected_by_wonder(pcity, B_HANGING)) {
-    faces++;
-    my_snprintf(bptr, nleft, get_improvement_name(B_HANGING));
-    bptr = end_of_strn(bptr, &nleft);
-    my_snprintf(bptr, nleft, _(". "));
-    bptr = end_of_strn(bptr, &nleft);
-  }
-  if (city_affected_by_wonder(pcity, B_BACH)) {
-    faces++;
-    my_snprintf(bptr, nleft, get_improvement_name(B_BACH));
-    bptr = end_of_strn(bptr, &nleft);
-    my_snprintf(bptr, nleft, _(". "));
-    bptr = end_of_strn(bptr, &nleft);
-  }
-  /* hack for eliminating gtk_set_line_wrap() -mck */
-  if (faces > 1) {
-    /* sizeof("Wonders: ") */
-    my_snprintf(bptr, nleft, _("\n              "));
-    bptr = end_of_strn(bptr, &nleft);
-  }
-  if (city_affected_by_wonder(pcity, B_SHAKESPEARE)) {
-    faces++;
-    my_snprintf(bptr, nleft, get_improvement_name(B_SHAKESPEARE));
-    bptr = end_of_strn(bptr, &nleft);
-    my_snprintf(bptr, nleft, _(". "));
-    bptr = end_of_strn(bptr, &nleft);
-  }
-  if (city_affected_by_wonder(pcity, B_CURE)) {
-    faces++;
-    my_snprintf(bptr, nleft, get_improvement_name(B_CURE));
-    bptr = end_of_strn(bptr, &nleft);
-    my_snprintf(bptr, nleft, _(". "));
-    bptr = end_of_strn(bptr, &nleft);
-  }
-
-  if (faces == 0) {
-    my_snprintf(bptr, nleft, _("None. "));
-  }
-
-  gtk_set_label(pdialog->hlabels[WONDERS], buf);
-}
-
-/**************************************************************************
-...
-**************************************************************************/
 GtkWidget *get_top_happiness_display(struct city *pcity)
 {
   return create_happiness_dialog(pcity)->shell;
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/gui-gtk/repodlgs.c freeciv-patched/client/gui-gtk/repodlgs.c
--- freeciv-cvs/client/gui-gtk/repodlgs.c	2003-06-30 12:18:27.000000000 +0100
+++ freeciv-patched/client/gui-gtk/repodlgs.c	2003-06-30 12:16:42.000000000 +0100
@@ -891,7 +891,8 @@
 void activeunits_list_callback(GtkWidget *w, gint row, gint column)
 {
   if ((unit_type_exists(activeunits_type[row])) &&
-      (can_upgrade_unittype(game.player_ptr, activeunits_type[row]) != -1))
+      (can_upgrade_unittype(game.player_ptr,
+			    activeunits_type[row], TRUE) != -1))
     gtk_widget_set_sensitive(upgrade_command, can_client_issue_orders());
 }
 
@@ -932,7 +933,7 @@
     return;
   /* puts(unit_types[ut1].name); */
 
-  ut2 = can_upgrade_unittype(game.player_ptr, activeunits_type[row]);
+  ut2 = can_upgrade_unittype(game.player_ptr, activeunits_type[row], TRUE);
 
   my_snprintf(buf, sizeof(buf),
 	  _("Upgrade as many %s to %s as possible for %d gold each?\n"
@@ -1014,7 +1015,7 @@
     memset(&unittotals, '\0', sizeof(unittotals));
     unit_type_iterate(i) {
       if ((unitarray[i].active_count > 0) || (unitarray[i].building_count > 0)) {
-	can = (can_upgrade_unittype(game.player_ptr, i) != -1);
+	can = (can_upgrade_unittype(game.player_ptr, i, TRUE) != -1);
         my_snprintf(buf[0], sizeof(buf[0]), "%-27s", unit_name(i));
 	my_snprintf(buf[1], sizeof(buf[1]), "%c", can ? '*': '-');
         my_snprintf(buf[2], sizeof(buf[2]), "%9d", unitarray[i].building_count);
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/gui-gtk-2.0/citydlg.c freeciv-patched/client/gui-gtk-2.0/citydlg.c
--- freeciv-cvs/client/gui-gtk-2.0/citydlg.c	2003-06-30 12:18:27.000000000 +0100
+++ freeciv-patched/client/gui-gtk-2.0/citydlg.c	2003-06-30 12:18:17.000000000 +0100
@@ -1505,7 +1505,7 @@
   get_city_dialog_production(pcity, buf, sizeof(buf));
 
   if (pcity->is_building_unit) {
-    cost = get_unit_type(pcity->currently_building)->build_cost;
+    cost = unit_value_adjusted(pcity->currently_building, pcity);
     descr = get_unit_type(pcity->currently_building)->name;
   } else {
     if (pcity->currently_building == B_CAPITAL) {
@@ -1513,7 +1513,7 @@
       gtk_widget_set_sensitive(pdialog->overview.buy_command, FALSE);
       cost = 0;
     } else {
-      cost = get_improvement_type(pcity->currently_building)->build_cost;;
+      cost = improvement_value_adjusted(pcity->currently_building, pcity);
     }
     descr = get_impr_name_ex(pcity, pcity->currently_building);
   }
@@ -2043,7 +2043,7 @@
       GINT_TO_POINTER(punit->id));
     gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);
 
-    if (can_upgrade_unittype(game.player_ptr, punit->type) == -1) {
+    if (can_upgrade_unittype(game.player_ptr, punit->type, TRUE) == -1) {
       gtk_widget_set_sensitive(item, FALSE);
     }
 
@@ -2221,7 +2221,7 @@
 
   if ((punit = player_find_unit_by_id(game.player_ptr, (size_t) data))) {
     ut1 = punit->type;
-    ut2 = can_upgrade_unittype(game.player_ptr, ut1);
+    ut2 = can_upgrade_unittype(game.player_ptr, ut1, TRUE);
 
     if (ut2 == -1) {
       /* this shouldn't generally happen, but it is conceivable */
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/gui-gtk-2.0/gotodlg.c freeciv-patched/client/gui-gtk-2.0/gotodlg.c
--- freeciv-cvs/client/gui-gtk-2.0/gotodlg.c	2003-06-30 12:18:27.000000000 +0100
+++ freeciv-patched/client/gui-gtk-2.0/gotodlg.c	2003-06-30 12:16:19.000000000 +0100
@@ -259,7 +259,7 @@
 
       gtk_list_store_set(store, &it,
         0, pcity->name,
-        1, (pcity->improvements[B_AIRPORT] == I_ACTIVE),
+        1, pcity->airlift,
         -1);
     }
     city_list_iterate_end;
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/gui-gtk-2.0/happiness.c freeciv-patched/client/gui-gtk-2.0/happiness.c
--- freeciv-cvs/client/gui-gtk-2.0/happiness.c	2003-06-30 12:18:27.000000000 +0100
+++ freeciv-patched/client/gui-gtk-2.0/happiness.c	2003-06-30 12:16:03.000000000 +0100
@@ -77,8 +77,6 @@
 					      *pdialog);
 static void happiness_dialog_update_units(struct happiness_dialog
 					  *pdialog);
-static void happiness_dialog_update_wonders(struct happiness_dialog
-					    *pdialog);
 
 /****************************************************************
 ...
@@ -193,7 +191,6 @@
   happiness_dialog_update_luxury(pdialog);
   happiness_dialog_update_buildings(pdialog);
   happiness_dialog_update_units(pdialog);
-  happiness_dialog_update_wonders(pdialog);
 }
 
 /**************************************************************************
@@ -269,59 +266,36 @@
 }
 
 /**************************************************************************
-...
+  Lists the buildings or Wonders that contribute to happiness
 **************************************************************************/
-static void happiness_dialog_update_buildings(struct happiness_dialog
-					      *pdialog)
+static void set_building_label(char *title, int improvs[B_LAST],
+			       int numperline, char *linespacer,
+			       struct city *pcity, GtkWidget *label)
 {
   int faces = 0;
-  char buf[512], *bptr = buf;
-  int nleft = sizeof(buf);
-  struct city *pcity = pdialog->pcity;
-  struct government *g = get_gov_pcity(pcity);
+  char buf[512], *bptr;
+  int nleft, i;
+
+  nleft = sizeof(buf);
+  bptr = buf;
 
-  my_snprintf(bptr, nleft, _("Buildings: "));
+  my_snprintf(bptr, nleft, title);
   bptr = end_of_strn(bptr, &nleft);
 
-  if (city_got_building(pcity, B_TEMPLE)) {
-    faces++;
-    my_snprintf(bptr, nleft, get_improvement_name(B_TEMPLE));
-    bptr = end_of_strn(bptr, &nleft);
-    my_snprintf(bptr, nleft, _(". "));
-    bptr = end_of_strn(bptr, &nleft);
-  }
-  if (city_got_building(pcity, B_COURTHOUSE) && g->corruption_level == 0) {
-    faces++;
-    my_snprintf(bptr, nleft, get_improvement_name(B_COURTHOUSE));
-    bptr = end_of_strn(bptr, &nleft);
-    my_snprintf(bptr, nleft, _(". "));
-    bptr = end_of_strn(bptr, &nleft);
-  }
-  if (city_got_building(pcity, B_COLOSSEUM)) {
-    faces++;
-    my_snprintf(bptr, nleft, get_improvement_name(B_COLOSSEUM));
-    bptr = end_of_strn(bptr, &nleft);
-    my_snprintf(bptr, nleft, _(". "));
-    bptr = end_of_strn(bptr, &nleft);
-  }
-  /* hack for eliminating gtk_set_line_wrap() -mck */
-  if (faces > 2) {
-    /* sizeof("Buildings: ") */
-    my_snprintf(bptr, nleft, _("\n              "));
-    bptr = end_of_strn(bptr, &nleft);
-  }
-  if (city_got_effect(pcity, B_CATHEDRAL)) {
-    faces++;
-    my_snprintf(bptr, nleft, get_improvement_name(B_CATHEDRAL));
-    bptr = end_of_strn(bptr, &nleft);
-    if (!city_got_building(pcity, B_CATHEDRAL)) {
-      my_snprintf(bptr, nleft, _("("));
-      bptr = end_of_strn(bptr, &nleft);
-      my_snprintf(bptr, nleft, get_improvement_name(B_MICHELANGELO));
-      bptr = end_of_strn(bptr, &nleft);
-      my_snprintf(bptr, nleft, _(")"));
+  faces = 0;
+  for (i = 0;i < game.num_impr_types; i++) if (improvs[i]) {
+    /* hack for eliminating gtk_set_line_wrap() -mck */
+    if (faces && faces % numperline == 0) {
+      my_snprintf(bptr, nleft, linespacer);
       bptr = end_of_strn(bptr, &nleft);
     }
+    faces++;
+    if (city_got_building(pcity,i)) {
+      my_snprintf(bptr, nleft, get_improvement_name(i));
+    } else {
+      my_snprintf(bptr, nleft, _("(%s)"), get_improvement_name(i));
+    }
+    bptr = end_of_strn(bptr, &nleft);
     my_snprintf(bptr, nleft, _(". "));
     bptr = end_of_strn(bptr, &nleft);
   }
@@ -331,7 +305,53 @@
     bptr = end_of_strn(bptr, &nleft);
   }
 
-  gtk_label_set_text(GTK_LABEL(pdialog->hlabels[BUILDINGS]), buf);
+  gtk_set_label(label, buf);
+}
+
+/**************************************************************************
+  Updates the lists of ordinary buildings and Wonders that affect the
+  number of happy/content citizens, using ruleset improvement effects
+**************************************************************************/
+static void happiness_dialog_update_buildings(struct happiness_dialog
+					      *pdialog)
+{
+  struct city *pcity = pdialog->pcity;
+  int i, improvs[B_LAST], forceimprovs[B_LAST];
+  Impr_Type_id impr;
+
+  for (i = 0; i < game.num_impr_types; i++) {
+    improvs[i] = forceimprovs[i] = FALSE;
+  }
+
+  city_effects_iterate(iter, pcity) {
+    switch(iter.imeff->type) {
+    case EFT_MAKE_CONTENT:
+    case EFT_MAKE_CONTENT_PCT:
+    case EFT_MAKE_HAPPY:
+      impr = eff_iterator_get_improvement(&iter);
+      if (improvement_exists(impr)) {
+        improvs[impr] = TRUE;
+      }
+      break;
+    case EFT_FORCE_CONTENT:
+    case EFT_FORCE_CONTENT_PCT:
+    case EFT_FORCE_HAPPY:
+      impr = eff_iterator_get_improvement(&iter);
+      if (improvement_exists(impr)) {
+        forceimprovs[impr] = TRUE;
+      }
+      break;
+    default:
+      break;
+    }
+  } city_effects_iterate_end;
+
+  set_building_label(_("Buildings: "), improvs, 3,
+                     _("\n              "),	/* sizeof("Buildings: ") */
+                     pcity, pdialog->hlabels[BUILDINGS]);
+  set_building_label(_("Wonders: "), forceimprovs, 2,
+                     _("\n              "),	/* sizeof("Wonders: ") */
+                     pcity, pdialog->hlabels[WONDERS]);
 }
 
 /**************************************************************************
@@ -378,62 +398,6 @@
 /**************************************************************************
 ...
 **************************************************************************/
-static void happiness_dialog_update_wonders(struct happiness_dialog
-					    *pdialog)
-{
-  int faces = 0;
-  char buf[512], *bptr = buf;
-  int nleft = sizeof(buf);
-  struct city *pcity = pdialog->pcity;
-
-  my_snprintf(bptr, nleft, _("Wonders: "));
-  bptr = end_of_strn(bptr, &nleft);
-
-  if (city_affected_by_wonder(pcity, B_HANGING)) {
-    faces++;
-    my_snprintf(bptr, nleft, get_improvement_name(B_HANGING));
-    bptr = end_of_strn(bptr, &nleft);
-    my_snprintf(bptr, nleft, _(". "));
-    bptr = end_of_strn(bptr, &nleft);
-  }
-  if (city_affected_by_wonder(pcity, B_BACH)) {
-    faces++;
-    my_snprintf(bptr, nleft, get_improvement_name(B_BACH));
-    bptr = end_of_strn(bptr, &nleft);
-    my_snprintf(bptr, nleft, _(". "));
-    bptr = end_of_strn(bptr, &nleft);
-  }
-  /* hack for eliminating gtk_set_line_wrap() -mck */
-  if (faces > 1) {
-    /* sizeof("Wonders: ") */
-    my_snprintf(bptr, nleft, _("\n              "));
-    bptr = end_of_strn(bptr, &nleft);
-  }
-  if (city_affected_by_wonder(pcity, B_SHAKESPEARE)) {
-    faces++;
-    my_snprintf(bptr, nleft, get_improvement_name(B_SHAKESPEARE));
-    bptr = end_of_strn(bptr, &nleft);
-    my_snprintf(bptr, nleft, _(". "));
-    bptr = end_of_strn(bptr, &nleft);
-  }
-  if (city_affected_by_wonder(pcity, B_CURE)) {
-    faces++;
-    my_snprintf(bptr, nleft, get_improvement_name(B_CURE));
-    bptr = end_of_strn(bptr, &nleft);
-    my_snprintf(bptr, nleft, _(". "));
-    bptr = end_of_strn(bptr, &nleft);
-  }
-
-  if (faces == 0) {
-    my_snprintf(bptr, nleft, _("None. "));
-  }
-
-  gtk_label_set_text(GTK_LABEL(pdialog->hlabels[WONDERS]), buf);
-}
-
-/**************************************************************************
-...
-**************************************************************************/
 GtkWidget *get_top_happiness_display(struct city *pcity)
 {
   return create_happiness_dialog(pcity)->shell;
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/gui-gtk-2.0/repodlgs.c freeciv-patched/client/gui-gtk-2.0/repodlgs.c
--- freeciv-cvs/client/gui-gtk-2.0/repodlgs.c	2003-06-30 12:18:27.000000000 +0100
+++ freeciv-patched/client/gui-gtk-2.0/repodlgs.c	2003-06-30 12:16:42.000000000 +0100
@@ -1001,7 +1001,8 @@
 
   if (row < n-2 &&
       unit_type_exists(activeunits_type[row]) &&
-      can_upgrade_unittype(game.player_ptr, activeunits_type[row]) != -1) {
+      can_upgrade_unittype(game.player_ptr,
+			   activeunits_type[row], TRUE) != -1) {
     gtk_widget_set_sensitive(upgrade_command, can_client_issue_orders());
   } else {
     gtk_widget_set_sensitive(upgrade_command, FALSE);
@@ -1030,7 +1031,7 @@
   if (!unit_type_exists(ut1))
     return;
 
-  ut2 = can_upgrade_unittype(game.player_ptr, activeunits_type[row]);
+  ut2 = can_upgrade_unittype(game.player_ptr, activeunits_type[row], TRUE);
 
   shell = gtk_message_dialog_new(
 	GTK_WINDOW(activeunits_dialog_shell),
@@ -1096,7 +1097,7 @@
     unit_type_iterate(i) {
     
       if ((unitarray[i].active_count > 0) || (unitarray[i].building_count > 0)) {
-	can = (can_upgrade_unittype(game.player_ptr, i) != -1);
+	can = (can_upgrade_unittype(game.player_ptr, i, TRUE) != -1);
 	
         gtk_list_store_append(activeunits_store, &it);
 	gtk_list_store_set(activeunits_store, &it,
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/gui-mui/dialogs.c freeciv-patched/client/gui-mui/dialogs.c
--- freeciv-cvs/client/gui-mui/dialogs.c	2003-06-30 12:18:27.000000000 +0100
+++ freeciv-patched/client/gui-mui/dialogs.c	2003-06-30 12:16:42.000000000 +0100
@@ -1854,7 +1854,7 @@
   int value;
 
   ut1 = punit->type;
-  ut2 = can_upgrade_unittype(game.player_ptr,ut1);
+  ut2 = can_upgrade_unittype(game.player_ptr, ut1, TRUE);
 
   if (ut2 == -1)
   {
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/gui-mui/gotodlg.c freeciv-patched/client/gui-mui/gotodlg.c
--- freeciv-cvs/client/gui-mui/gotodlg.c	2003-06-30 12:18:27.000000000 +0100
+++ freeciv-patched/client/gui-mui/gotodlg.c	2003-06-30 12:16:19.000000000 +0100
@@ -58,7 +58,7 @@
 {
   static char name[80];
   sz_strlcpy(name, pcity->name);
-  if (pcity->improvements[B_AIRPORT] == I_ACTIVE)
+  if (pcity->airlift)
     sz_strlcat(name, "(A)");
   *array = name;
 }
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/gui-mui/mapclass.c freeciv-patched/client/gui-mui/mapclass.c
--- freeciv-cvs/client/gui-mui/mapclass.c	2003-06-30 12:18:27.000000000 +0100
+++ freeciv-patched/client/gui-mui/mapclass.c	2003-06-30 12:16:42.000000000 +0100
@@ -2962,7 +2962,7 @@
 	  }
 	}
 
-	if (can_upgrade_unittype(game.player_ptr,punit->type) != -1)
+	if (can_upgrade_unittype(game.player_ptr, punit->type, TRUE) != -1)
 	{
 	  if ((entry = MUI_MakeObject(MUIO_Menuitem, _("Upgrade"), NULL, MUIO_Menuitem_CopyStrings, 0)))
 	  {
